		.ltorg

VISOLY_START:
	mov r11,r11
	b _doReset

@
@ Visoly start-code@ must be sent before any command
@
init_flashcart:
	adr		r0, flash_constants
	ldmia	r0,{r2-r5}
	add		r0,r0,#16

@   WriteRepeat (0x987654, 0x5354, 1);
	ldr		r1,[r0]
	strh	r2,[r1]

@   WriteRepeat ( 0x12345, 0x1234, 500);
	ldr		r1,[r0,#4]
	mov		r12,#500
0:
	strh	r3,[r1]
	subs	r12,r12,#1
	bne		0b

@   WriteRepeat ( 0x12345, 0x5354, 1);
	ldr		r1,[r0,#4]
	strh	r2,[r1]
	
@   WriteRepeat ( 0x12345, 0x5678, 500);
	mov		r12,#500
1:
	strh	r4,[r1]
	subs	r12,r12,#1
	bne		1b

@   WriteRepeat (0x987654, 0x5354, 1);
	ldr		r1,[r0]
	strh	r2,[r1]

@   WriteRepeat ( 0x12345, 0x5354, 1);
	ldr		r1,[r0,#4]
	strh	r2,[r1]

@   WriteRepeat (0x765400, 0x5678, 1);
	ldr		r1,[r0,#12]
	strh	r4,[r1]

@   WriteRepeat ( 0x13450, 0x1234, 1);
	ldr		r1,[r0,#16]
	strh	r3,[r1]

@   WriteRepeat ( 0x12345, 0xabcd, 500);
	ldr		r1,[r0,#4]
	mov		r12,#500
2:
	strh	r5,[r1]
	subs	r12,r12,#1
	bne		2b

@   WriteRepeat (0x987654, 0x5354, 1);
	ldr		r1,[r0]
	strh	r2,[r1]

	bx		lr

@ r0 = New rom start value
@ 10 bits
@ 9-3 = 16Mbit -> 256Kbit
@ 2-0 = 128Mbit -> 32Mbit
@ Only bits 3,1,0 allowed for older carts
set_rom_start:
	ldr	r1,=0x096B592E
	strh	r0,[r1]
	bx		lr

flash_constants:
        .word   0x5354
        .word   0x1234
        .word   0x5678
        .word   0xabcd

        .word   (0x00987654 * 2) + 0x08000000
        .word   (0x00012345 * 2) + 0x08000000
        .word   (0x00007654 * 2) + 0x08000000
        .word   (0x00765400 * 2) + 0x08000000
        .word   (0x00013450 * 2) + 0x08000000
	.ltorg 
@ Restore cartstart & Softreset
_doReset:
	bl		init_flashcart
	mov		r0, #0
	ldr		r1,=0x3007ffa	@must be 0 before swi 0x00 is run, otherwise it tries to start from 0x02000000.
	strh		r0,[r1]
	bl		set_rom_start
	@EZ4 Reset:
	adr r0,EZ4_Reset
	adr lr,2f
	bx r0


	.thumb
EZ4_Reset:
	@snippit_start
	mov r0,#0x20
	lsl r3,r0,#22 @#0x8000000 r3
	lsl r0,r0,#12 @#0x0020000
	add r4,r3,r0  @#0x8020000 r4
	add r5,r4,r0  @#0x8040000 r5
	lsl r1,r0,#8  @#0x2000000
	add r2,r3,r1  @#0xa000000
	lsr r1,r3,#4  @#0x0800000
	sub r6,r2,r1  @#0x9800000
	lsr r1,r1,#4  @#0x0080000
	add r6,r6,r1  @#0x9880000 r6
	sub r2,r2,r0  @#0x9fe0000 r2
	sub r7,r2,r0  @#0x9fc0000 r7

	mov r0,#210
	lsl r0,r0,#8  @0xd200 r0
	mov r1,#21
	lsl r1,r1,#8  @0x1500 r1

	strh r0,[r2]
	strh r1,[r3]
	strh r0,[r4]
	strh r1,[r5]

	lsr r0,r3,#12 @#0x0008000 r0

	strh r0,[r6]
	strh r1,[r7]
	@snippit_end 
	
	bx lr
	.arm
2:
	mov		r0, #8		@VRAM clear
	swi		0x010000
	swi		0x000000

		.ltorg
VISOLY_END:

		.ltorg
        @.end

